package de.fraunhofer.fit.train.model;

import org.bson.types.ObjectId;
import org.springframework.data.annotation.Id;
import org.springframework.data.mongodb.core.mapping.Document;
import org.springframework.stereotype.Repository;

import com.google.gson.annotations.Expose;
import com.google.gson.annotations.SerializedName;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiModelProperty;

@Api(value = "Suffix object model aims to hold the complete URI, including the version and state, The sufffix coud be requested for new "
		+ "resource/metadata/asset which should be an DOI, based on the limitations of the proprietary verion/reporitory.",
tags = {"suffix"})
@Repository
@Document(collection = "suffix")
public class Suffix {
	
	
	@ApiModelProperty(notes = "Unique and Internal identifier of the related objet. This field is randomly generated by the platform.", 
            example = "Auto Generated",  position = 0)
	@Id
	@SerializedName("_id")
	@Expose
	private ObjectId _id;
	
	
	@ApiModelProperty(notes = "The field suffixStr aims to hold the content of the suffix as string. This field is randomly generated by the platform.", 
            example = "5e42cf239296cb2b74b2b15c", position = 1)
	@SerializedName("suffixStr")
	@Expose
	private String suffixStr;
	
	@ApiModelProperty(notes = "The field suffixURI aims to hold the content of the suffix URI as string. This field is randomly generated by the platform.", 
            example = "http://167.172.175.112:6666/5e42cef39296cb2b74b2b15b/5e42cf239296cb2b74b2b15c/", position = 2)
	@SerializedName("suffixURI")
	@Expose
	private String suffixURI;
	
	
	@ApiModelProperty(notes = "The field version aims to hold the content related to the version. This field is mandatory should be informed by the user of this service.", 
            example = "http://167.172.175.112:6666/5e42cef39296cb2b74b2b15b/5e42cf239296cb2b74b2b15c/", position = 3, required = true)
	@SerializedName("version")
	@Expose
	private String version;

	@ApiModelProperty(notes = "The field version aims to hold the state of the Suffix. This field is mandatory should be informed by the user of this service.", 
            example = "The supported values are DRAFT, PUBLISHED or DEPRICATED.", position = 4, required = true)
	@SerializedName("sufixStateEnum")
	@Expose
	private SufixStateEnum sufixStateEnum;
	

	
	
	
	public SufixStateEnum getSufixStateEnum() {
		return sufixStateEnum;
	}



	public void setSufixStateEnum(SufixStateEnum sufixStateEnum) {
		this.sufixStateEnum = sufixStateEnum;
	}



	public String getVersion() {
		return version;
	}



	public void setVersion(String version) {
		this.version = version;
	}



	public ObjectId get_id() {
		return _id;
	}



	public void set_id(ObjectId _id) {
		this._id = _id;
	}



	public String getSuffixStr() {
		return suffixStr;
	}



	public void setSuffixStr(String suffixStr) {
		this.suffixStr = suffixStr;
	}



	public String getSuffixURI() {
		return suffixURI;
	}



	public void setSuffixURI(String suffixURI) {
		this.suffixURI = suffixURI;
	}
	

	
	
	

}
